質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

89.13%

Djangoでherokuにデプロイしたい!

受付中

回答 2

投稿 編集

  • 評価
  • クリップ 1
  • VIEW 2,417

yutthi555

score 12

 前提・実現したいこと

DjangoアプリをHerokuにデプロイする
こちらに書かれている内容の通りに一通り実行してみました。
$ git push heroku master
もうまく実行でき
いざ、$heroku open を実行したところ
画面上には
Application error
An error occurred in the application and your page could not be served. If you are the application owner, check your logs for details.
と表示されました。
$ heroku logs
$ heroku ps
で確認したところ、下記のように表示がされました。

 発生している問題・エラーメッセージ

(venv) Yoshis-mac:myProject Yoshinori$ heroku logs
2018-04-02T05:49:41.357097+00:00 app[web.1]:   File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/wsgiapp.py", line 65, in load
2018-04-02T05:49:41.357100+00:00 app[web.1]:   File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/wsgiapp.py", line 52, in load_wsgiapp
.
.
.
2018-04-02T05:49:41.654745+00:00 app[web.1]:     raise HaltServer(reason, self.WORKER_BOOT_ERROR)
2018-04-02T05:49:41.654747+00:00 app[web.1]: gunicorn.errors.HaltServer: <HaltServer 'Worker failed to boot.' 3>
2018-04-02T05:49:41.767566+00:00 heroku[web.1]: Process exited with status 1
2018-04-02T05:49:41.785374+00:00 heroku[web.1]: State changed from up to crashed
2018-04-02T05:50:08.670379+00:00 heroku[router]: at=error code=H10 desc="App crashed" method=GET path="/" host=rhubarb-pie-95237.herokuapp.com request_id=6528fd9b-465f-4b5d-8f85-4eb395cbe06d fwd="157.65.124.14" dyno= connect= service= status=503 bytes= protocol=https
2018-04-02T05:50:09.490415+00:00 heroku[router]: at=error code=H10 desc="App crashed" method=GET path="/favicon.ico" host=rhubarb-pie-95237.herokuapp.com request_id=b0c2d952-a6c7-4e39-afaa-419bbeb09927 fwd="157.65.124.14" dyno= connect= service= status=503 bytes= protocol=https
2018-04-02T06:14:35.000000+00:00 app[api]: Build started by user cookingpapa2578@gmail.com
2018-04-02T06:15:03.167307+00:00 heroku[web.1]: State changed from crashed to starting
2018-04-02T06:15:02.673271+00:00 app[api]: Deploy 5a3816a1 by user cookingpapa2578@gmail.com
2018-04-02T06:14:35.000000+00:00 app[api]: Build succeeded
2018-04-02T06:15:02.673271+00:00 app[api]: Release v9 created by user cookingpapa2578@gmail.com
2018-04-02T06:15:12.058446+00:00 heroku[web.1]: Starting process with command `python ./main.py 14322`
2018-04-02T06:15:15.777426+00:00 heroku[web.1]: Process exited with status 2
2018-04-02T06:15:15.728380+00:00 app[web.1]: python: can't open file './main.py': [Errno 2] No such file or directory
2018-04-02T06:15:15.947626+00:00 heroku[web.1]: State changed from starting to crashed
2018-04-02T06:15:15.949988+00:00 heroku[web.1]: State changed from crashed to starting
2018-04-02T06:15:24.083290+00:00 heroku[web.1]: Starting process with command `python ./main.py 36815`
2018-04-02T06:15:26.725271+00:00 heroku[web.1]: State changed from starting to crashed
2018-04-02T06:15:26.598349+00:00 heroku[web.1]: Process exited with status 2
2018-04-02T06:15:26.519548+00:00 app[web.1]: python: can't open file './main.py': [Errno 2] No such file or directory
2018-04-02T06:15:36.412318+00:00 heroku[router]: at=error code=H10 desc="App crashed" method=GET path="/" host=rhubarb-pie-95237.herokuapp.com request_id=b3cb09b3-5db1-42db-a96f-960fdd90929f fwd="157.65.124.14" dyno= connect= service= status=503 bytes= protocol=https
2018-04-02T06:15:37.153952+00:00 heroku[router]: at=error code=H10 desc="App crashed" method=GET path="/favicon.ico" host=rhubarb-pie-95237.herokuapp.com request_id=9f874ee1-2cf3-4361-9165-5d02b7cb5c33 fwd="157.65.124.14" dyno= connect= service= status=503 bytes= protocol=https
2018-04-02T06:16:23.669804+00:00 heroku[router]: at=error code=H10 desc="App crashed" method=GET path="/" host=rhubarb-pie-95237.herokuapp.com request_id=6d14e0df-67c2-4c53-a239-1ec62cee3ef7 fwd="157.65.124.14" dyno= connect= service= status=503 bytes= protocol=https
2018-04-02T06:16:24.399976+00:00 heroku[router]: at=error code=H10 desc="App crashed" method=GET path="/favicon.ico" host=rhubarb-pie-95237.herokuapp.com request_id=e9dad4f0-a6a5-4dd0-8b66-db50fd4ca399 fwd="157.65.124.14" dyno= connect= service= status=503 bytes= protocol=https
2018-04-02T06:26:08.884602+00:00 heroku[router]: at=error code=H10 desc="App crashed" method=GET path="/" host=rhubarb-pie-95237.herokuapp.com request_id=0a700e97-21d9-4b2a-913f-7c43f56c269c fwd="157.65.124.14" dyno= connect= service= status=503 bytes= protocol=https
2018-04-02T06:26:09.670249+00:00 heroku[router]: at=error code=H10 desc="App crashed" method=GET path="/favicon.ico" host=rhubarb-pie-95237.herokuapp.com request_id=076c3a0a-0a8d-4b9d-9db2-cb946199758b fwd="157.65.124.14" dyno= connect= service= status=503 bytes= protocol=https
2018-04-02T06:41:45.303228+00:00 heroku[web.1]: State changed from crashed to starting
2018-04-02T06:41:53.429328+00:00 heroku[web.1]: Starting process with command `python ./main.py 31254`
2018-04-02T06:41:55.938239+00:00 heroku[web.1]: State changed from starting to crashed
2018-04-02T06:41:55.846930+00:00 heroku[web.1]: Process exited with status 2
2018-04-02T06:41:55.787850+00:00 app[web.1]: python: can't open file './main.py': [Errno 2] No such file or directory
2018-04-02T06:43:07.000000+00:00 app[api]: Build started by user cookingpapa2578@gmail.com
2018-04-02T06:43:36.100775+00:00 app[api]: Deploy e369da41 by user cookingpapa2578@gmail.com
2018-04-02T06:43:36.100775+00:00 app[api]: Release v10 created by user cookingpapa2578@gmail.com
2018-04-02T06:43:36.354054+00:00 heroku[web.1]: State changed from crashed to starting
2018-04-02T06:43:07.000000+00:00 app[api]: Build succeeded
2018-04-02T06:43:43.579876+00:00 heroku[web.1]: Starting process with command `python ./main.py 54325`
2018-04-02T06:43:46.314385+00:00 heroku[web.1]: Process exited with status 2
2018-04-02T06:43:46.347671+00:00 heroku[web.1]: State changed from starting to crashed
2018-04-02T06:43:46.265834+00:00 app[web.1]: python: can't open file './main.py': [Errno 2] No such file or directory
(venv) Yoshis-mac:myProject Yoshinori$

 試したこと

error code h10の意味は
Heroku Error Codes
Web dynoがクラッシュしていると書いてあります。
同じ内容でerrorを起こしていそうな方の記事をみてみるとProcfileに問題があるのではと思い、内容を変更しましたが、変わりませんでした。
Django: Heroku Failing to launch, at=error code=H10 desc=“App crashed”

guniconeもこちらの記事通りインストールしました。
Deploying Python Applications with Gunicorn

インストールしたあと呼び出せていないということなのでしょうか。
gunicorn.errors.HaltServer: <HaltServer 'Worker failed to boot.' 3>
Procfile
この一文が原因でしょうか。
Haltserverも調べてみたんですがよくわかりません。

Procfile

web: gunicorn myDjango.wsgi --log-file -
web: gunicorn gettingstarted.wsgi
web: python ./main.py $PORT

どうぞ宜しくお願いいたします。

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 過去に投稿した質問と同じ内容の質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 2

0

python: can't open file './main.py': [Errno 2] No such file or directoryと出ていますね。
Procfileに書くのはweb: gunicorn myproject.wsgi --log-file -のみでよいはずです。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2018/04/02 19:03

    他の場所で`main.py`は呼び出されていませんでした。
    上記に書ききれなかった部分です。
    ```2018-04-02T05:49:41.360906+00:00 app[web.1]: ModuleNotFoundError: No module named 'hello'```
    という箇所がありますが、これは関係していますでしょうか。

    ```(venv) Yoshis-mac:myProject Yoshinori$ heroku logs
    2018-04-02T05:49:41.357097+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/wsgiapp.py", line 65, in load
    2018-04-02T05:49:41.357100+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/wsgiapp.py", line 52, in load_wsgiapp
    2018-04-02T05:49:41.357098+00:00 app[web.1]: return self.load_wsgiapp()
    2018-04-02T05:49:41.357102+00:00 app[web.1]: return util.import_app(self.app_uri)
    2018-04-02T05:49:41.357103+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/util.py", line 352, in import_app
    2018-04-02T05:49:41.357105+00:00 app[web.1]: __import__(module)
    2018-04-02T05:49:41.360906+00:00 app[web.1]: ModuleNotFoundError: No module named 'hello'
    2018-04-02T05:49:41.361980+00:00 app[web.1]: [2018-04-02 05:49:41 +0000] [9] [INFO] Worker exiting (pid: 9)
    2018-04-02T05:49:41.468801+00:00 app[web.1]: [2018-04-02 05:49:41 +0000] [10] [INFO] Booting worker with pid: 10
    2018-04-02T05:49:41.511916+00:00 app[web.1]: [2018-04-02 05:49:41 +0000] [10] [ERROR] Exception in worker process
    2018-04-02T05:49:41.511931+00:00 app[web.1]: Traceback (most recent call last):
    2018-04-02T05:49:41.511933+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 578, in spawn_worker
    2018-04-02T05:49:41.511936+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/workers/base.py", line 126, in init_process
    2018-04-02T05:49:41.511935+00:00 app[web.1]: worker.init_process()
    2018-04-02T05:49:41.511938+00:00 app[web.1]: self.load_wsgi()
    2018-04-02T05:49:41.511939+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/workers/base.py", line 135, in load_wsgi
    2018-04-02T05:49:41.511941+00:00 app[web.1]: self.wsgi = self.app.wsgi()
    2018-04-02T05:49:41.511943+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/base.py", line 67, in wsgi
    2018-04-02T05:49:41.511944+00:00 app[web.1]: self.callable = self.load()
    2018-04-02T05:49:41.511946+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/wsgiapp.py", line 65, in load
    2018-04-02T05:49:41.511947+00:00 app[web.1]: return self.load_wsgiapp()
    2018-04-02T05:49:41.511949+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/wsgiapp.py", line 52, in load_wsgiapp
    2018-04-02T05:49:41.511951+00:00 app[web.1]: return util.import_app(self.app_uri)
    2018-04-02T05:49:41.511952+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/util.py", line 352, in import_app
    2018-04-02T05:49:41.511954+00:00 app[web.1]: __import__(module)
    2018-04-02T05:49:41.518133+00:00 app[web.1]: ModuleNotFoundError: No module named 'hello'
    2018-04-02T05:49:41.518450+00:00 app[web.1]: [2018-04-02 05:49:41 +0000] [10] [INFO] Worker exiting (pid: 10)
    2018-04-02T05:49:41.646294+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 202, in run
    2018-04-02T05:49:41.646290+00:00 app[web.1]: Traceback (most recent call last):
    2018-04-02T05:49:41.648513+00:00 app[web.1]: self.manage_workers()
    2018-04-02T05:49:41.648517+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 544, in manage_workers
    2018-04-02T05:49:41.648518+00:00 app[web.1]: self.spawn_workers()
    2018-04-02T05:49:41.648520+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 612, in spawn_workers
    2018-04-02T05:49:41.648523+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 244, in handle_chld
    2018-04-02T05:49:41.648525+00:00 app[web.1]: self.reap_workers()
    2018-04-02T05:49:41.648522+00:00 app[web.1]: time.sleep(0.1 * random.random())
    2018-04-02T05:49:41.648529+00:00 app[web.1]: raise HaltServer(reason, self.WORKER_BOOT_ERROR)
    2018-04-02T05:49:41.648527+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 524, in reap_workers
    2018-04-02T05:49:41.648531+00:00 app[web.1]: gunicorn.errors.HaltServer: <HaltServer 'Worker failed to boot.' 3>
    2018-04-02T05:49:41.648534+00:00 app[web.1]:
    2018-04-02T05:49:41.648536+00:00 app[web.1]: During handling of the above exception, another exception occurred:
    2018-04-02T05:49:41.648537+00:00 app[web.1]:
    2018-04-02T05:49:41.648539+00:00 app[web.1]: Traceback (most recent call last):
    2018-04-02T05:49:41.648540+00:00 app[web.1]: File "/app/.heroku/python/bin/gunicorn", line 11, in <module>
    2018-04-02T05:49:41.648542+00:00 app[web.1]: sys.exit(run())
    2018-04-02T05:49:41.648550+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/wsgiapp.py", line 74, in run
    2018-04-02T05:49:41.654718+00:00 app[web.1]: WSGIApplication("%(prog)s [OPTIONS] [APP_MODULE]").run()
    2018-04-02T05:49:41.654722+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/base.py", line 203, in run
    2018-04-02T05:49:41.654724+00:00 app[web.1]: super(Application, self).run()
    2018-04-02T05:49:41.654726+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/app/base.py", line 72, in run
    2018-04-02T05:49:41.654728+00:00 app[web.1]: Arbiter(self).run()
    2018-04-02T05:49:41.654729+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 231, in run
    2018-04-02T05:49:41.654731+00:00 app[web.1]: self.halt(reason=inst.reason, exit_status=inst.exit_status)
    2018-04-02T05:49:41.654733+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 344, in halt
    2018-04-02T05:49:41.654735+00:00 app[web.1]: self.stop()
    2018-04-02T05:49:41.654736+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 393, in stop
    2018-04-02T05:49:41.654738+00:00 app[web.1]: time.sleep(0.1)
    2018-04-02T05:49:41.654740+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 244, in handle_chld
    2018-04-02T05:49:41.654742+00:00 app[web.1]: self.reap_workers()
    2018-04-02T05:49:41.654744+00:00 app[web.1]: File "/app/.heroku/python/lib/python3.6/site-packages/gunicorn/arbiter.py", line 524, in reap_workers```

    キャンセル

  • 2018/04/02 19:20

    修正したProcfileをコミットしてからプッシュしましたか?

    キャンセル

  • 2018/04/02 19:36

    はい。
    $git commit -m ""
    $ git push heroku master
    という手順でpushを行いました。

    キャンセル

0

Procfileを修正する場合、次のような手順にするとよいです。

1、Procfile自体をいったん削除して git add .してgit commit -m "procfile delete"などでコミット
2、この状態で一度プッシュ。git push heroku masterなどのコマンド。
3、Procfileを新規作成して、内容を正しいものにして保存。
4、git add .git commit -m "new procfile"などとしてコミット。
5、git push heroku masterでプッシュ。

お試しくださいませ。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 89.13%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる

同じタグがついた質問を見る